#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>
#include <conio.h>
#ifdef WIN3264
/*
9x,ME,NT,2000,XP WIN3264 _MBCS
      NT,2000,XP WIN3264 _UNICODE UNICODE
         2000,XP WIN3264 _UNICODE UNICODE W2KXP
http://discypus.jp/wiki/?Windows%2F%A5%B8%A5%E3%A5%F3%A5%AF%A5%B7%A5%E7%A5%F3%BA%EE%C0%AE
http://www.microsoft.com/japan/msdn/library/ja/jpdnw2k/htm/ntfs2.asp
GetFileInformationByHandle()
BY_HANDLE_FILE_INFORMATION nNumberOfLinks 
Number of links to this file. For the FAT file system this member is always 1. For NTFS, it may be more than 1. 
*/
#include <tchar.h>
#include <windows.h>
#include <winuser.h>
#undef toupper
#define toupper TOUPPER
int toupper(c) {if('a'<=c&&c<='z')c-=0x20;return c;}
#define iskanji(x) IsDBCSLeadByte(x)
#ifdef _UNICODE
#define CRLF _T("\r\n")
#undef _ftprintf
#define _ftprintf u_ftprintf
#else
#define CRLF _T("\n")
#endif
#define FINDDATA std_find_data64
#define _findfirst(a,b) std_findfirst64(a,b)
#define _findnext(a,b) std_findnext64(a,b)
#define _findclose(a) std_findclose(a)
#define localtime64(a) std_localtime64(a)
#define FMT _T("%19I64u")
#define TM std_tm64
#include "std64.h"
#else
#define iskanji(x) ( ((x) >= 0x81 && (x) <= 0x9f) || ((x) >= 0xe0 && (x) <= 0xfc) )
#define CRLF "\n"
#define FINDDATA _finddata_t
#define FMT "%11lu"
#define TM tm
#define _TXCHAR char
#define _tmain main
#define _tprintf printf
#define _ftprintf fprintf
#define _stprintf sprintf
#endif

_TXCHAR *pgname;

int lf;
int pf;
int lc;
int tf;
int maxline = 23;
int maxcolm = 80;
#ifdef WIN3264
DWORD stdouttype = FILE_TYPE_UNKNOWN;
HANDLE stdouth;
#endif

int s_tprintf(const _TCHAR *format,...)
{
    va_list argp;
    int ret = 0;
#ifdef _UNICODE
    _TXCHAR buffer[_MAX_PATH + 1];
    DWORD len;
    DWORD NumberOfCharsWritten;
    BOOL sts;
#endif

    if ( format != NULL && *format != 0 ) {
        va_start(argp, format);
#ifdef _UNICODE
        if ( stdouttype == FILE_TYPE_CHAR ) {
            ret = len = _vsntprintf(buffer, _MAX_PATH + 1, format, argp);
            if ( len > 0 ) {
                sts = WriteConsole(stdouth, buffer, len, &NumberOfCharsWritten, NULL);
                if ( sts == 0 ) ret = -1;
            }
        } else {
            ret = _vtprintf(format, argp);
        }
#else
        ret = _vtprintf(format, argp);
#endif
        va_end(argp);
    }
    return ret;
}

#ifdef _UNICODE
int u_ftprintf(FILE *fp,const _TCHAR *format,...)
{
    va_list argp;
    int ret = 0;
    _TXCHAR buffer[_MAX_PATH + 100];
    DWORD len;
    DWORD NumberOfCharsWritten;
    BOOL sts;
    HANDLE h;
    int type = 0;

    if ( fp == stdout || fp == stderr ) {
        h = GetStdHandle(fp == stdout ? STD_OUTPUT_HANDLE : STD_ERROR_HANDLE);
        if ( h != INVALID_HANDLE_VALUE ) {
            if ( GetFileType(h) == FILE_TYPE_CHAR ) {
                type = 1;
            }
        }
    }
    if ( format != NULL && *format != 0 ) {
        va_start(argp, format);
        if (  type == 1 ) {
            ret = len = _vsntprintf(buffer, _MAX_PATH + 100, format, argp);
            if ( len > 0 ) {
                sts = WriteConsole(h, buffer, len, &NumberOfCharsWritten, NULL);
                if ( sts == 0 ) ret = -1;
            }
        } else {
            ret = _vftprintf(fp, format, argp);
        }
        va_end(argp);
    }
    return ret;
}
#endif

void help(void)
{
    _ftprintf(stderr,_T("usage: %s [/p] [/l] [/w|/a|/c] [file...]") CRLF,pgname);
    exit(1);
}

int msglen(_TXCHAR *p)
{
    int n = 0;
    BOOL sts;
    WORD CharType;

    if ( p ) {
        while ( *p ) {
            sts = GetStringTypeEx(LOCALE_USER_DEFAULT, CT_CTYPE3, p, 1, &CharType);
            if ( sts ) {
                if ( *p >= 0x20 && *p < 0x7f ) {
                    n += 1;
                } else if ( *p >= 0x80 && *p < 0x100 && (CharType & C3_HALFWIDTH) ) {
                    n += 1;
                } else if ( *p >= 0xff61 && (CharType & C3_HALFWIDTH) ) {
                    n += 1;
                } else if ( CharType == C3_NOTAPPLICABLE || 
/*                            CharType & C3_NONSPACING || 
                            CharType & C3_DIACRITIC || 
                            CharType & C3_VOWELMARK || */
                            *p < 0x20 ) {
                    ;
                } else {
                    n += 2;
                }
            }
            p++;
        }
    }
    return n;
}

void list(_TXCHAR *p)
{
    struct FINDDATA buf;
    _TXCHAR b[7];
    _TXCHAR *q;
    long h;
    struct TM *t;
    int line;

    if ( *p == '\\' && *(p + 1) == '\0' ) {
            _stprintf(b,_T("\\*.*"));
            p = b;
    } else if ( isalpha(*p) && *(p + 1) == ':' ) {
        if ( *(p + 2) == '\\' && *(p + 3) == '\0' ) {
            _stprintf(b,_T("%c:\\*.*"),*p);
            p = b;
        } else if ( *(p + 2) == '\0' ) {
            _stprintf(b,_T("%c:*.*"),*p);
            p = b;
        }
    }
    if ( (h = _findfirst(p,&buf)) == -1 ) {
        _ftprintf(stderr,_T("%s: %s: %s") CRLF,pgname,p,_tcserror(errno));
    } else {
        do {
            if ( pf ) {
                if ( ++lc >= maxline ) {
                    lc = 1;
                    cputs("Press any key to continue ");
                    if ( getch() == 0x03 ) {
                        cputs("^C\r\n");
                        exit(1);
                    }
                    cputs("\r(continue)                \r");
                }
            }
#ifdef WIN3264
            if ( tf == 'C' ) {
                t = localtime64(&buf.time_create);
            } else if ( tf == 'A' ) {
                t = localtime64(&buf.time_access);
            } else {
                t = localtime64(&buf.time_write);
            }
            s_tprintf(_T("%4d-%02d-%02d %02d:%02d:%02d.%.03d "),
                1900 + t->tm_year, t->tm_mon + 1, t->tm_mday,
                t->tm_hour, t->tm_min, t->tm_sec, t->tm_msec);
#else
            if ( tf == 'C' ) {
                t = localtime(&buf.time_create);
            } else if ( tf == 'A' ) {
                t = localtime(&buf.time_access);
            } else {
                t = localtime(&buf.time_write);
            }
            s_tprintf(_T("%4d-%02d-%02d %02d:%02d:%02d "),
                1900 + t->tm_year, t->tm_mon + 1, t->tm_mday,
                t->tm_hour, t->tm_min, t->tm_sec);
#endif
            if ( buf.attrib & _A_SUBDIR ) {
#ifdef WIN3264
                if ( buf.attrib & _A_RPRS ) {
                    s_tprintf(_T("<JUNCTION>          "));
                } else {
                    s_tprintf(_T("<DIR>               "));
                }
#else
                s_tprintf(_T("<DIR>       "));
#endif
            } else if ( buf.attrib & 0x40 ) {
                s_tprintf(FMT _T("D"),buf.size);
            } else if ( buf.attrib & 0x80 ) {
                s_tprintf(FMT _T("!"),buf.size);
            } else {
                s_tprintf(FMT _T(" "),buf.size);
            }
            if ( buf.attrib & _A_ARCH ) {
                s_tprintf(_T("A"));
            } else {
                s_tprintf(_T(" "));
            }
            if ( buf.attrib & _A_SYSTEM ) {
                s_tprintf(_T("S"));
            } else {
                s_tprintf(_T(" "));
            }
            if ( buf.attrib & _A_HIDDEN ) {
                s_tprintf(_T("H"));
            } else {
                s_tprintf(_T(" "));
            }
            if ( buf.attrib & _A_RDONLY ) {
                s_tprintf(_T("R"));
            } else {
                s_tprintf(_T(" "));
            }
#ifdef WIN3264
            if ( buf.attrib & _A_CMPRS ) {
                s_tprintf(_T("C"));
            } else if ( buf.attrib & _A_ENCRYPT ) {
                s_tprintf(_T("E"));
            } else {
                s_tprintf(_T(" "));
            }
            if ( buf.attrib & _A_SPRS ) {
                s_tprintf(_T("s"));
            } else {
                s_tprintf(_T(" "));
            }
#endif
#if 0
#ifdef W2KXP
            s_tprintf(_T("%u "),sbuf.st_nlink);
#endif
#endif
            if ( lf ) {
#ifdef WIN3264
                CharLower(buf.name);
#else
                for ( q = buf.name ; *q ; q++ ) {
                    if ( iskanji(*q) ) {
                        if ( *(q + 1) != '\0' ) {
                           q++;
                        }
                    } else if ( isalpha(*q) ) {
                        *q = tolower(*q);
                    }
                }
#endif
            }
            s_tprintf(_T(" "));
            s_tprintf(_T("%s"),buf.name);
            s_tprintf(CRLF);
#ifdef WIN3264
#ifdef _UNICODE
            line = msglen(buf.name) + 51;
#else
            line = strlen(buf.name) + 51;
#endif
#else
            line = strlen(buf.name) + 37;
#endif
/*s_tprintf(_T("line=%d maxcolm=%d line%%maxcolm=%d\r\n"),line,maxcolm,line / maxcolm);*/
            lc += line / maxcolm;
        } while ( _findnext(h,&buf) == 0 );
    }
    _findclose(h);
}

int _tmain(int argc,_TXCHAR **argv)
{
    int i;
    int c;
    _TXCHAR *p;
#ifdef WIN3264
    CONSOLE_SCREEN_BUFFER_INFO csi;
    BOOL sts;
#endif

    pgname = argv[0];
#ifdef _UNICODE
    setmode(fileno(stdout),O_BINARY);
    setmode(fileno(stderr),O_BINARY);
#endif
    while ( argc >= 2 && (*argv[1] == '-' || *argv[1] == '/') ) { /* option */
        if ( _tcscmp(argv[1],_T("--")) == 0 ) { /* end of options */
            ++argv ; --argc ;
            break;
        } else if ( (c = *(p = argv[1])) == '/' || c == '-' ) {
            p++;
            while ( (c = toupper(*(p++))) != 0 ) {
                if ( c == 'L' ) {
                    lf = 1;
                } else if ( c == 'P' ) {
                    lc = 0;
                    pf = 1;
                } else if ( c == 'C' ) {
                    tf = 'C';
                } else if ( c == 'A' ) {
                    tf = 'A';
                } else if ( c == 'W' ) {
                    tf = 'W';
                } else if ( c == '/' ) {
                    ;
                } else if ( c == '-' ) {
                    ;
                } else if ( c == 'H' ) {
                    help();
                } else if ( c == '?' ) {
                    help();
                } else {
                    _ftprintf(stderr,_T("%s: bad option %c") CRLF,pgname,c);
                    _ftprintf(stderr,_T("for more infomation: %s /?") CRLF,pgname);
                    exit(1);
                }
            }
        } else {
            _ftprintf(stderr,_T("%s: bad option %c") CRLF,pgname,c);
            _ftprintf(stderr,_T("for more infomation: %s /?") CRLF,pgname);
            exit(1);
        }
        ++argv ; --argc ;
    }

#ifdef WIN3264
    stdouth = GetStdHandle(STD_OUTPUT_HANDLE);
    if ( stdouth != INVALID_HANDLE_VALUE ) {
        stdouttype = GetFileType(stdouth);
        sts = GetConsoleScreenBufferInfo(stdouth,&csi);
/*_tprintf("X=%d,Y=%d Top=%d Bottom=%d Left=%d Right=%d\n",
csi.dwSize.X,csi.dwSize.Y,csi.srWindow.Top,csi.srWindow.Bottom,csi.srWindow.Left,csi.srWindow.Right);*/
        if ( sts ) {
            maxline = csi.srWindow.Bottom - csi.srWindow.Top - 1;
            maxcolm = csi.dwSize.X;
        } else {
            maxline = 23;
            maxcolm = 80;
        }
    }
#endif
    if ( argc == 1 ) {
        list(_T("*.*"));
    } else {
        for ( i = 1 ; i < argc ; ++i ) {
            list(argv[i]);
        }
    }
    return 0;
}
